import java.util.*;
import greenfoot.*;

/**
 * Elternklasse von Peetie. Wird für diverse Variablen + Methoden benutzt, die Peetie erbt, damit die Klasse Peetie schlank bleibt und von den Schüler/innen einfach bedient werden kann.
 */
public abstract class AI_Robot extends Actor
{
    // Werte nach Belieben ändern:
    protected int peetieStartposX = 193; // Achtung: Weltgröße und Gridgröße berücksichtigen (World-Klasse Mars)!
    protected int peetieStartposY = 300;
    protected int delay = 25;   // Wie lange wartet Peetie zwischen einzelnen Aktionen (gehe Links, geheRechts...)
    // Möglich auch warten(int delay)
    protected String peetieDefaultImage = "peetie_runter_50.png";

    // Andere Variablen, nicht ändern
    protected Mars mars; // Wird in der addedToWorld-Methode initialisiert

    protected boolean buttonsSindEingeblendet = true;
    protected boolean missionBeendet = false;


    public AI_Robot() {
    }

    public void act() {
        // Wenn die act-Methode als Loop laufen soll, folgende Zeile entkommentieren:
        // this.run();
    }

    public void runOrganize() {
        // Blendet Buttons vor Beginn von run() aus und danach wieder ein
        this.mars.buttonsVerstecken();
        this.warten(1);
        this.run();
        this.warten(50);
        this.mars.buttonsZeigen();
       // Greenfoot.stop();
    }
    /** 
     * #########################################################
     * #########################################################
     * ################# PEETIE-BEFEHLE ########################
     * #########################################################
     * #########################################################
     * werden von Schueler/innen verwendet (geheRechts usw.)
     */



    /**
     * #################### TEXT EINLESEN / AUSGEBEN ######################
     */
    public String textEinlesen() {
        return Greenfoot.ask("");
    }

    public double kommazahlEinlesen() {
        return Double.parseDouble(this.textEinlesen());
    }
    public int ganzzahlEinlesen() {
        return Integer.parseInt(this.textEinlesen());
    }
    private String inputToString(String text) {
        return text;
    }

    private String inputToString(int text) {
        return Integer.toString(text);
    }

    private String inputToString(double text) {
        return Double.toString(text);
    }


    // Ausgabe auf Handy - 2sek, dann neuer Text ueberschreibt
    public void textAufDisplay(String text) {
        smartphoneText(text);
    }

    public void textAufDisplay(double text) {
        smartphoneText(inputToString(text));
    }

    public void textAufDisplay(int text) {
        smartphoneText(inputToString(text));
    }

    private void smartphoneText(String t) { // sondervariante fuer E06 M01 (Smartphoneausgabe)
        Label l = new Label();
        GreenfootImage g = new GreenfootImage(t, 20, new Color(212, 15, 15), new Color(235, 235, 235));
        l.setImage(g);
        int startX = 120;
        this.mars.addObject(l, startX, 450);
        for(int x = startX; x <= this.mars.getWidth()/2; x += 8) {
            l.setLocation(x, 450);
            this.warten(1);
        }
        this.warten(200);
                for(int x = this.mars.getWidth()/2; x <= this.mars.getWidth() - startX; x += 8) {
            l.setLocation(x, 450);
            this.warten(1);
        }
                this.mars.removeObject(l);

        this.warten(33);
    }

    /* 
     * #########################################################
     * #########################################################
     * ################# PRIVATE METHODEN ######################
     * #########################################################
     * #########################################################
     * werden von Standard-Methoden benutzt,
     * werden aber von Schüler/innen nicht benutzt 
     * 
     */

    private void warten() {
        Greenfoot.delay(this.delay);
    }

    private void warten(int del) {
        Greenfoot.delay(del);
    }

    /**
     * SETUP-/INITIALIZE-functions
     */
    public void addedToWorld(World w) {
        this.startpositionEinnehmen(w);
        this.mars = (Mars)w;
    }

    public void startpositionEinnehmen(World w) {
        this.setLocation(this.peetieStartposX, this.peetieStartposY);
        this.setImage(this.peetieDefaultImage);
    }

    /* Andere Methoden, die Schüler/innen nicht brauchen: */
    public void run() {
        // Wird in Peetie überschrieben
    }

    /* Getter, Setter */
    public int getPeetieStartposX() {
        return this.peetieStartposX;
    }

    public int getPeetieStartposY() {
        return this.peetieStartposY;
    }

    public int getDelay() {
        return this.delay;
    }

    public void setDelay(int delay) {
        this.delay = delay;
    }
}
